%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Local Log-Euclidean Covariance Matrix (L2ECM)
%for Image Representation and Its Applications (ECCV 2012 , (3) : 469-482)
%Peihua Li, QiLong Wang 2 Oct. 2012
%Contact: wangqilong.415@163.com, peihualj@hotmail.com
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [fimage] = buildfeatures(inimage)

[height width depth] = size(inimage);

fdim = 2;  %%% dimension of raw features

if depth == 1
    gimage = double(inimage);
else if depth == 3
        gimage = double(rgb2gray(inimage));
    end
end

gimage = gimage./255;


filter=fspecial('gaussian',3,0.5);
gimage = conv2(gimage, filter, 'same'); 

%%%%Central difference
%filter = [-1 0 1];       
% %horizontal edge
% himage = conv2(gimage, filter, 'same');
% %vertical edge
% vimage = conv2(gimage, filter', 'same');

%filter = [-1 2 -1];
% %horizontal 2nd derivative
% shimage = conv2(gimage, filter, 'same');
% %vertical 2nd derivative     
% svimage = conv2(gimage, filter', 'same');


%%%%Robinson operator
% filter = [0 -1 -1;1 0 -1;1 1 0]; 
% filter1 = [-1 -1 0;-1 0 1;0 1 1]; 

%%%%Commpass operator  2011 12.25 1156
% filter = [1 -1 -1;1 -2 -1;1 1 1]; 
% filter1 = [-1 -1 1;-1 -2 1;1 1 1]; 

%%%%Kirsch operator       Southwest and Southeast
filter = [-3 5 5;-3 0 5;-3 -3 -3]; 
filter1 = [5 5 -3;5 0 -3;-3 -3 -3]; 

% %%%%Kirsch operator     Northeast and Northwest
% filter = [-3 -3 -3;5 0 -3;5 5 -3]; 
% filter1 = [-3 -3 -3;-3 0 5;-3 5 5]; 

% 1st derivative
himage = conv2(gimage, filter, 'same');
vimage = conv2(gimage, filter1, 'same');

% %2nd derivative
% shimage = conv2(himage, filter, 'same');
% %2nd derivative     
% svimage = conv2(vimage, filter1, 'same');

fimage = zeros(height, width, fdim);

 fimage(:,:,1)   = abs(himage);
 fimage(:,:,2)   = abs(vimage);

%%%%%%% 
% fimage(:,:,1)   = gimage;
% fimage(:,:,2)   = abs(himage);
% fimage(:,:,3)   = abs(vimage);
% fimage(:,:,4)   = abs(shimage);
% fimage(:,:,5)   = abs(svimage);
