%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Local Log-Euclidean Covariance Matrix (L2ECM)
%for Image Representation and Its Applications (ECCV 2012 , (3) : 469-482)
%Peihua Li, Qilong Wang 2 Oct. 2012
%Contact: wangqilong.415@163.com, peihualj@hotmail.com
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ feature im_mask grid_x grid_y] = covcalculator(detwindow, patch_size, sampling_step, step)

im_features = buildfeatures(detwindow); 
n=size(im_features,3);
ones_mat=ones(n,n);
ones_mat=triu(ones_mat);
triu_idx=find(ones_mat==1);
[im_covs im_mask grid_x  grid_y]  = dense_cov_integral(im_features, patch_size, sampling_step);   
local_covs = zeros(size(im_covs,1),size(im_covs,2),length(triu_idx));
local_covs(:, : ,:)=im_covs(:,:,triu_idx);

%%%%%%%%check local log cov
fail = 0;
[my mx] = size(im_mask);   
[y x]= find( im_mask < n); %%%%% concatenation 30
len = length(x);
[use_x use_y] = find(im_mask == n,1,'first');
use_l = length(use_x);
if use_l < 1
   fail = 1;
end    
bound = 16;
if len >= 1
    for k =1:len
        lx = max(x(k)-bound,1);    
        rx = min(x(k)+bound,mx);
        ly = max(y(k)-bound,1);    
        ry = min(y(k)+bound,my);
        [use_idx use_idy] = find(im_mask(ly:ry,lx:rx) == n,1,'first');
        local_covs_t = local_covs(ly:ry,lx:rx,:);
        use_len = length(use_idx);
        if use_len >= 1
          local_covs(y(k),x(k),:) =  local_covs_t(use_idx,use_idy,:); 
%           local_covs(y(k),x(k),:) =  local_covs(use_x,use_y,:);   
        else
          local_covs(y(k),x(k),:) =  local_covs(use_x,use_y,:);   
        end
    end
end
%%%%%%%%check local log cov

% [g_y g_x bin] = size(local_covs);
% local_covs = reshape(local_covs,g_y*g_x,bin);
feature = local_covs;
if fail == 1
   feature = [];
end
end